

//	This source and file packaging method apply to GNU General Public License. 
//			Copyright (C) 2001-2013 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			MLS file packager
//  		
//			written by Dzinleski Jasenko  2010 - 2013


#include 	<stdio.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	<math.h>
#include 	<errno.h>
#include 	<dirent.h>
#define		csl	28

FILE		*f1,*f2,*f3,*f4,*f5;

//char		infn[256]="book_sd.txt";
char		out1fn[256]="mls_o1.mar";
char		out2fn[256]="mls_o2.mar";
char		out3fn[256]="mls_o3.mar";
char		out4fn[256]="mls_o4.mar";

bool		df=false;
bool		of=true;

char		dirn[256];	int	dirni=0;
char		v_ext[256];	int	vexti=0;

char		c_l[256]="{[AZ][az]}{[::]}{[AZ][az][09][__][..][\\\\][**][////][::][--][  ][??][##]}";

int			b12=((0xffff>>4 )<<4 );
int			b11=((0xffff>>5 )<<5 );
int			b10=((0xffff>>6 )<<6 );
int			b09=((0xffff>>7 )<<7 );
int			b08=((0xffff>>8 )<<8 );
int			b07=((0xffff>>9 )<<9 );
int			b06=((0xffff>>10)<<10);
int			b05=((0xffff>>11)<<11);
int			b04=((0xffff>>12)<<12);

int			ba16[16][16][16][16][3];	int	ba16i=0;

long		da[16][3];
char		p_s[256];
char		n_s[512];
char		rp_f[256];
char		rp_f_[256];

struct		dirent 	*dentries;
//struct		stat 	fp;
	
char		r1[256]="FILENAME ";
char		r2[256]="SIZE ";
char		r3[256]="CHECKSUM STRING :";

char		outpath[256]="d:\\e\\f\\";
char		outdir[256];
char		outfilen[256];


#ifdef _WINDOWS_

	#include 	<dir.h>
	#include 	<sys/stat.h>

	#define		os	1

	DIR			*dirl;	

	int	mkdir_(char dn[255]){return(mkdir(dn));}

	int p_d_(char cmd[256],char lx[256])
	{

		char		dl1[256]="Volume";
		char		dl2[256]="File";
		char		ds[256]="Directory of";
		char		dm[256]="<DIR>";
		char		dn[256];
		char		fn[256];
		char		ll[256];
		char		cmd1[256]="dir/s/a "; 
		char		cmd2[256]=" > mls_o1.mar";
		char		cmd3[256];
		char		st[256];
	
		int	i,j,k,l;
		int	fbyte;
		int	cn,cs;

		for(i=0;i<256;++i){cmd3[i]='\0';}
		l=0;for(i=0;i<strlen(cmd1);++i){cmd3[l]=cmd1[i];++l;}
		for(i=0;i<strlen(cmd);++i){cmd3[l]=cmd[i];++l;}
		for(i=0;i<strlen(cmd2);++i){cmd3[l]=cmd2[i];++l;}
	
		while(!system(NULL)){};
		system(cmd3);
		while(!system(NULL)){};

		f1=fopen("mls_o1.mar","rb");
		f2=fopen("mls_o2.mar","w");
		fbyte=getc(f1);
		while(!feof(f1))
		{

			for(i=0;i<256;++i){ll[i]='\0';}
			l=0;while(fbyte!=13&&fbyte!=10){ll[l]=fbyte;++l;fbyte=getc(f1);}
			while(fbyte==13||fbyte==10){fbyte=getc(f1);}
			
			//
			for(i=0;i<strlen(ll);++i)
			{
				if(ll[i]==dm[0])
				{
					for(j=i;j<i+strlen(dm);++j){if(ll[j]!=dm[j-i]){break;}}
					if(j==i+strlen(dm)){break;}
				}
			}
			if(i!=strlen(ll)){continue;}
			//
			for(i=0;i<strlen(ll);++i)
			{
				if(ll[i]==dl1[0])
				{
					for(j=i;j<i+strlen(dl1);++j){if(ll[j]!=dl1[j-i]){break;}}
					if(j==i+strlen(dl1)){break;}
				}
			}
			if(i!=strlen(ll)){continue;}
			//
			for(i=0;i<strlen(ll);++i)
			{
				if(ll[i]==dl2[0])
				{
					for(j=i;j<i+strlen(dl2);++j){if(ll[j]!=dl2[j-i]){break;}}
					if(j==i+strlen(dl2)){break;}
				}
			}
			if(i!=strlen(ll)){continue;}			
			//
			
			for(i=0;i<strlen(ll);++i)
			{
				if(ll[i]==ds[0])
				{
					for(j=i;j<i+strlen(ds);++j){if(ll[j]!=ds[j-i]){break;}}
					if(j==i+strlen(ds)){break;}
				}
			}
			if(i!=strlen(ll))
			{

				for(i=1+j;i<strlen(ll);++i){if(ll[i]!=' '){break;}}
				for(j=0;j<256;++j){dn[j]='\0';}
				l=0;for(j=i;j<strlen(ll);++j){dn[l]=ll[j];++l;}
				dn[strlen(dn)]='\\';

			}else{
			
				l=strlen(ll);
				for(i=l-1;i>0;--i)
				{
					if(ll[i]==' '&&ll[i-1]>='0'&&ll[i-1]<='9')
			    	{
						--i;
						j=i;cn=0;cs=0;
						while((ll[j]>='0'&&ll[j]<='9')||(ll[j]==':'))
						{
							if(ll[j]>='0'&&ll[j]<='9'){++cn;--j;continue;}
							if(ll[j]==':'){if(cn>=1){++cs;--j;continue;}}
							--j;
						}
						if(ll[j]==' '&&cs==1&&cn>=2&&cn<=4){break;}
					}
				}
                if(ll[j]==' '&&cs==1&&cn>=2&&cn<=4){k=j+1+cn+cs;}else{continue;}

				//
				for(j=k+1+2;j<strlen(ll);++j)
				{
					if(ll[j]!=' ')
					{
						for(i=j;i<strlen(ll);++i){if(ll[i]==' '){break;}}
						if(i!=strlen(ll)){break;}
					}
				}
				k=i;
				//
				
				for(j=0;j<256;++j){fn[j]='\0';}
				l=0;for(j=k+1;j<strlen(ll);++j){fn[l]=ll[j];++l;}//printf("%s\n",fn);
				for(i=0;i<256;++i){st[i]='\0';}
				l=0;for(i=0;i<strlen(dn);++i){st[l]=dn[i];++l;}//st[l]='/';++l;
				for(i=0;i<strlen(fn);++i){st[l]=fn[i];++l;}//printf("%s\n",st);
				//fprintf(f2,"%s\n",st);
				
				if
				(
				(strlen(lx)==0)
				||
				((strlen(lx)==3)&&(lx[0]=='*')&&(lx[1]=='.')&&(lx[2]=='*'))
				||
				((strlen(lx)==1)&&(lx[0]=='*'))
				)
				{
					f5=fopen(st,"rb");
					if(f5==NULL){}else{
						if(feof(f5)){fclose(f5);}else{
							if(getc(f5)==-1){fclose(f5);}else{
								fclose(f5);
								fprintf(f2,"%s\n",st);
							}
						}
					}
				}
				
				if((lx[0]=='*')&&(lx[1]=='.')&&(lx[2]!='*'))
				{
					k=-1+strlen(lx);
					for(j=-1+strlen(fn);j>=0&&lx[k]!='.'&&fn[j]!='.';--j){if(fn[j]!=lx[k]){break;}--k;}
					if(lx[k]=='.'&&fn[j]=='.')
					{
						f5=fopen(st,"rb");
						if(f5==NULL){}else{
							if(feof(f5)){fclose(f5);}else{
								if(getc(f5)==-1){fclose(f5);}else{
									fclose(f5);
									fprintf(f2,"%s\n",st);
								}
							}
						}
					}
				}
				
				k=-1+strlen(lx);
				for(j=-1+strlen(fn);j>=0&&k>=0&&lx[k]!='.'&&fn[j]!='.';--j){if(fn[j]!=lx[k]){break;}--k;}
				if(fn[j]=='.')
				{
					f5=fopen(st,"rb");
					if(f5==NULL){}else{
						if(feof(f5)){fclose(f5);}else{
							if(getc(f5)==-1){fclose(f5);}else{
								fclose(f5);
								fprintf(f2,"%s\n",st);
							}
						}
					}				
				}

			}
		}
		fclose(f1);
		fclose(f2);
			
	return(0);
	
	}

	int	p_d(char dir_n[256])
	{

		int				i,j,k,l;
		DIR				*dirl;	
		struct dirent 	*dentries;
		char			st[256];


		dirl=opendir(dir_n);if(dirl==NULL){return(0);}else{

		if(!df){fprintf(f1,"%c%cdirectory listing of %s%c%c",(char)13,(char)10,dir_n,(char)13,(char)10);}else{printf("directory listing of %s\n",dir_n);}

		rewinddir(dirl);
		dentries=readdir(dirl);
	
		while(dentries!=NULL)
		{
			if(strlen(dentries->d_name)<=2){dentries=readdir(dirl);continue;}
			l=0;for(i=-1+strlen(dentries->d_name);i>=-3-1+strlen(dentries->d_name);--i){if(dentries->d_name[i]=='.'){break;}else{++l;}}			
			if(!(l<=3))
			{
				for(i=0;i<256;++i){st[i]='\0';}
				j=0;for(i=0;i<strlen(dir_n);++i){st[j]=dir_n[i];++j;}
				for(i=0;i<strlen(dentries->d_name);++i){st[j]=dentries->d_name[i];++j;}st[j]='\\';++j;
				p_d(st);

			}else{
					if(vexti!=0&&strlen(dentries->d_name)>2)
					{
						k=0;
						for(j=i;j<strlen(dentries->d_name);++j){if(v_ext[k]!=dentries->d_name[j]){break;}++k;}
						if(j==strlen(dentries->d_name)){	
							if(!df){
							
										for(i=0;i<256;++i){st[i]='\0';}
										j=0;for(i=0;i<strlen(dir_n);++i){st[j]=dir_n[i];++j;}
										for(i=0;i<strlen(dentries->d_name);++i){st[j]=dentries->d_name[i];++j;}
										//printf("%s\n",st);
										f5=fopen(st,"rb");
										if(f5!=NULL&&getc(f5)!=-1)
										{
											fclose(f5);
											fprintf(f2,"%s%s%c%c",dir_n,dentries->d_name,(char)13,(char)10);
											fprintf(f1,"\t%s%c%c",dentries->d_name,(char)13,(char)10);
										}
										
									}else{printf("\t%s\n",dentries->d_name);}}
					}else{	
						if(!df){
									if(strlen(dentries->d_name)>2)
									{
									
										for(i=0;i<256;++i){st[i]='\0';}
										j=0;for(i=0;i<strlen(dir_n);++i){st[j]=dir_n[i];++j;}
										for(i=0;i<strlen(dentries->d_name);++i){st[j]=dentries->d_name[i];++j;}
										//printf("%s\n",st);
										f5=fopen(st,"rb");
										if(f5!=NULL&&getc(f5)!=-1)
										{
											fclose(f5);
											fprintf(f2,"%s%s%c%c",dir_n,dentries->d_name,(char)13,(char)10);
											fprintf(f1,"\t%s%c%c",dentries->d_name,(char)13,(char)10);}
										}

								}else{printf("\t%s\n",dentries->d_name);}}
			}
			dentries=readdir(dirl);
		}
		}
		return(0);
	}
	
#else

	#include 	<unistd.h>
	#include 	<wait.h>

	#ifndef __int64
	typedef long long __int64 ;
	#endif

	#define		os	2

	int p_1_(char *ar[],char ofn[256])
	{

	int 	i,j,k,l;
	int 	outf[2];
	int	status;

	pipe(outf);
	pid_t pid=fork();
	if(pid==0)
	{
		//dup2(0,fileno(stdout));   //Console
		dup2(outf[1],fileno(stdout));
		if((status=execvp(ar[0],ar))<0){while(wait(&status)!= pid);}
	}

	if(pid==0){return(1);}else{

		close(outf[1]);
		dup2(outf[0],fileno(stdin));

		FILE *f=fdopen(outf[0],"rt");
		char buffer[32];
		FILE *o=fopen(ofn,"w");

		while(!feof(f)){fgets(buffer,32,f);fprintf(o,"%s",buffer);/*printf("%s",buffer);*/}
		fclose(o);

	}
	return(0);
	}

	int mkdir_(char cmd_2[256])
	{
	char		cmd_1[256]="mkdir";
	//char		cmd_2[256]=" ";
	//char		cmd_3[256]=" ";
	//char		cmd_4[256]=" ";
	
	char		*cmd_[5];

	cmd_[0]=cmd_1;
	cmd_[1]=cmd_2;
	cmd_[2]=NULL;
	cmd_[3]=NULL;
	cmd_[4]=NULL;

	return(p_1_(cmd_,"out.txt"));

	}

	int p_d_(char cmd_4[256],char lx[256])
	{
	
	int		i,j,k,l;
	int		fbyte;

	char		dn[256];
	char		fn[256];
	char		ll[256];
	char		st[256];
		
	char		cmd_1[256]="ls";
	char		cmd_2[256]="-l";
	char		cmd_3[256]="-R";
	//char		cmd_4[256]="/mnt/sdcard/";
	
	char		*cmd_[5];
	static char 	*ar[]={"ls","-l","-R","/mnt/sdcard/",NULL};

	cmd_[0]=cmd_1;
	cmd_[1]=cmd_2;
	cmd_[2]=cmd_3;
	cmd_[3]=cmd_4;
	cmd_[4]=NULL;

	if(0==p_1_(cmd_,out1fn))
	{

		FILE *f1=fopen(out1fn,"rb");
		FILE *f2=fopen(out2fn,"w");
		fbyte=getc(f1);
		while(!feof(f1))
		{

			for(i=0;i<256;++i){ll[i]='\0';}
			l=0;while(fbyte!=13&&fbyte!=10){ll[l]=fbyte;++l;fbyte=getc(f1);}
			while(fbyte==13||fbyte==10){fbyte=getc(f1);}

			if(ll[0]=='/')
			{
				for(j=0;j<256;++j){dn[j]='\0';}
				l=0;for(i=0;i<strlen(ll)&&ll[i]!=':';++i){dn[l]=ll[i];++l;}
				dn[l]='/';
				continue;
			}

			if(ll[0]!='-'){continue;}

			for(j=-1+strlen(ll);j>=0;--j){if(ll[j]=='.'){break;}}
			if(j!=-1)
			{
				for(j=0;j<256;++j){fn[j]='\0';}
				for(j=-1+strlen(ll);j>=0;--j){if(ll[j]==':'){j+=2;break;}}if(j==-1){continue;}
				l=0;for(i=j+1;i<strlen(ll);++i){if(ll[i]==' '&&l==0){continue;}else{fn[l]=ll[i];++l;}}
				//printf("%s\n",fn);
				for(j=-1+strlen(fn);j>=0;--j){if(fn[j]=='.'){break;}}
					
				if
				(
				(strlen(lx)==0)
				||
				((strlen(lx)==3)&&(lx[0]=='*')&&(lx[1]=='.')&&(lx[2]=='*'))
				||
				((strlen(lx)==1)&&(lx[0]=='*'))
				)
				{
					for(i=0;i<256;++i){st[i]='\0';}
					j=0;for(i=0;i<strlen(dn);++i){st[j]=dn[i];++j;}

					for(i=0;i<strlen(fn);++i)
					{
						if
						(
							fn[i]!='!'&&
							fn[i]!=':'&&
							fn[i]!=','&&
							fn[i]!='*'&&
							fn[i]!='?'&&
							fn[i]!='@'&&
							fn[i]!='\''&&
							fn[i]!='#'
						)
						{st[j]=fn[i];++j;}else{break;}
					}
					if(i==strlen(fn))
					{
						//printf("%s\n",st);
						f5=fopen(st,"rb");
						if(f5==NULL){continue;}else{
								if(feof(f5)){fclose(f5);continue;}else{
									if(getc(f5)==-1){fclose(f5);continue;}else{
										fclose(f5);
										fprintf(f2,"%s\n",st);
									}
								}
						}
					}	
				}
				
				if((lx[0]=='*')&&(lx[1]=='.')&&(lx[2]!='*'))
				{
				k=-1+strlen(lx);
				for(j=-1+strlen(fn);j>=0&&lx[k]!='.'&&fn[j]!='.';--j){if(fn[j]!=lx[k]){break;}--k;}
				if(lx[k]=='.'&&fn[j]=='.')
				{
					for(i=0;i<256;++i){st[i]='\0';}
					j=0;for(i=0;i<strlen(dn);++i){st[j]=dn[i];++j;}
					for(i=0;i<strlen(fn);++i)
					{
						if
						(
							fn[i]!='!'&&
							fn[i]!=':'&&
							fn[i]!=','&&
							fn[i]!='*'&&
							fn[i]!='?'&&
							fn[i]!='@'&&
							fn[i]!='\''&&
							fn[i]!='#'
						)
						{st[j]=fn[i];++j;}else{break;}
					}
					if(i==strlen(fn))
					{
						//printf("%s\n",st);
						f5=fopen(st,"rb");
						if(f5==NULL){continue;}else{
								if(feof(f5)){fclose(f5);continue;}else{
									if(getc(f5)==-1){fclose(f5);continue;}else{
										fclose(f5);
										fprintf(f2,"%s\n",st);
									}
								}
						}
					}	
				}
				}
			}
		}
		fclose(f1);
		fclose(f2);

	}else{return(0);}
	return(0);
	}
	
#endif



double p_val(char arr0[256])
{
	int	sig=0;
	int	j=0,k=0,l;

	long		fr;
	int		rvi;
	__int64		rvl;
	__int64	rvd;
	double		rvd_;

	char 		arr1[256];

	for(j=0;j<strlen(arr0);++j){if(arr0[j]=='-'){sig=1;break;}}

	for(j=0;j<256;++j){arr1[j]='\0';}
	l=0;for(j=0;j<strlen(arr0);++j){if((arr0[j]>='0'&&arr0[j]<='9')||(arr0[j]=='.'||arr0[j]==',')){arr1[l]=arr0[j];++l;}}

	for(j=0;j<256;++j){arr0[j]='\0';}l=0;for(j=0;j<strlen(arr1);++j){arr0[l]=arr1[j];++l;}

	for(j=0;j<strlen(arr0);++j){if(arr0[j]=='.'){break;}}

	if(j==strlen(arr0))
	{
		rvl=0;l=-1;
		for(j=-1+strlen(arr0);j>=0;--j)
		{
			++l;rvl+=(__int64)(-48+arr0[j])*pow(10,l);
		}
		rvi=(int)rvl;
		rvd_=(double)rvl;

	}else{

			fr=0;l=-1;
			for(k=-1+strlen(arr0);k>j;--k)
			{
				++l;fr+=(long)(-48+arr0[k])*pow(10,l);
			}

			rvd=0;l=-1;
			for(k=j-1;k>=0;--k)
			{
				++l;rvd+=(__int64)(-48+arr0[k])*pow(10,l);

			}rvd*=(__int64)pow(10,strlen(arr0)-j-1);

			rvd_=(double)(rvd+(__int64)fr)/(__int64)pow(10,strlen(arr0)-j-1);
				
	}

	if(sig==0){return(rvd_);}else{return(-1.0*rvd_);}

}

double p_v(char pv_a1[256])
{

	bool	df=false;
	int	i,l;
	double	p_v;

	p_v=0;l=-1;
	for(i=-1+strlen(pv_a1);i>=0;--i)
	{
		++l;p_v+=(double)(-48+(int)pv_a1[i])*pow(10,l);
		if(df){printf("%d %e\n",-48+(int)pv_a1[i],pow(10,l));}
	}
	return(p_v);

}

int p_f_(long ar1)
{
	int	i,j,l,n;
	__int64	r,k,m,ti,tj;

	char ta[256];int	tai=-1+256;

	for(i=0;i<256;++i){ta[i]='\0';}

	r=0;ti=10;tj=ar1;
	while(tj>0)
	{

		if((((__int64)(tj/ti))*ti)-(((double)(tj/ti))*ti)==(double)0.00)
		{r=tj-((__int64)(tj/ti))*ti;}else{r=tj-((__int64)(tj/ti))*ti;--r;}

		tj-=r;
		//printf("!%c!",(48+(int)(r/(ti/10))));
		ta[tai]=(48+(int)(r/(ti/(__int64)10)));--tai;
				
		ti*=(__int64)10;

	}
	for(j=0;j<256;++j){rp_f[j]='\0';}
	j=0;l=0;for(i=0;i<256;++i){if(j==0){if(ta[i]!='\0'){j=1;rp_f[l]=ta[i];++l;/*printf("%c",ta[i]);*/}}else{rp_f[l]=ta[i];++l;/*printf("%c",ta[i]);*/}}/*printf("\n");*/

	return(0);
}

int p_f(double pf_r1)
{

	bool	df=false;
	int	i,j;
	int	l,l_,q;
	double pf_r1_;

	pf_r1_=pf_r1;
	for(i=0;i<256;++i){rp_f[i]='\0';}i=0;
	if(pf_r1==0){rp_f[i]='0';return(0);}

	l=0;while((pf_r1-pow(10,l))/(1000*pow(10,l))>10*(0.001)){++l;}l_=l;q=l;

	if(df){printf("%d %d\n",(int)(pf_r1/pow(10,l)),l );}
	if((int)(pf_r1/pow(10,l))<10)
	{
		rp_f[i]=48+(int)(pf_r1/pow(10,l));++i;
		if(df){printf("0.%d ",(int)(pf_r1/pow(10,l)));}
	}else{
		rp_f[i]=48+(int)(pf_r1/pow(10,l))/10;++i;
		if(df){printf("1.%d ",(int)(pf_r1/pow(10,l))/10);}
		rp_f[i]=48+pf_r1/pow(10,l)-10*(int)((pf_r1/pow(10,l))/10);++i;
		if(df){printf("2.%d ",(int)(pf_r1/pow(10,l))-10*(int)(pf_r1/pow(10,l))/10);}
	}
	if(df){printf("?%s?\n",rp_f);}

	pf_r1=pf_r1-pow(10,l)*(int)(pf_r1/pow(10,l));

	while(l>0)
	{
		l=0;while((pf_r1-pow(10,l))/(1000*pow(10,l))>10*(0.001)){++l;}
		if(df){printf("%e\n",(pf_r1-pow(10,l)*(int)(pf_r1/pow(10,l))));}
		j=l;while(j+1<l_){rp_f[i]='0';++i;++j;}l_=l;
		if((int)(pf_r1/pow(10,l))<10)
		{
			rp_f[i]=48+(int)(pf_r1/pow(10,l));++i;
			if(df){printf("0.%d ",(int)(pf_r1/pow(10,l)));}
		}else{
			rp_f[i]=48+(int)(pf_r1/pow(10,l))/10;++i;
			if(df){printf("1.%d ",(int)(pf_r1/pow(10,l))/10);}
			rp_f[i]=48+pf_r1/pow(10,l)-10*(int)((pf_r1/pow(10,l))/10);++i;
			if(df){printf("2.%d ",(int)(pf_r1/pow(10,l))-10*(int)(pf_r1/pow(10,l))/10);}
		}
		
		if(df){printf("?%s?\n",rp_f);}
		pf_r1=pf_r1-pow(10,l)*(int)(pf_r1/pow(10,l));
	}
	if(df){printf("?%s?\n",rp_f);}
	if(pf_r1_-p_v(rp_f)==-900){rp_f[-1+strlen(rp_f)]='\0';}
	//printf("%e\n",pf_r1_-p_v(rp_f));
	return(0);

}

int p_format(double ar1,char fm[256],char ar2[256])
{

	int		i,j,k,l,m,n;
	int		sig=0;
	int		ar2i=-1+256;

	char		lfm[256]="0000000000";
	bool		li=true;
	
	//0.00
	//#.00
	//#.##
	//000000
	//######
	//#,###,##0.00
	//
	
	if(ar1<0){ar1*=(double)-1;sig=1;}
	for(j=0;j<256;++j){ar2[j]='\0';}

	if(ar1==0){i=0;for(j=0;j<strlen(fm);++j){ar2[i]=fm[j];++i;}

		for(i=0;i<strlen(ar2);++i){if(ar2[i]=='#'){ar2[i]=' ';}}
		for(i=0;i<strlen(ar2);++i){if(ar2[i]==' '&&ar2[i+1]==','){ar2[i+1]=' ';}}
		return(0);
	}

	if(strlen(fm)!=0)
	{
		m=-1+strlen(fm);
		n=256-strlen(fm);

		for(i=-1+strlen(fm);i>=0;--i){if(fm[i]=='.'){break;}}//decimal point point
		if(i==-1)
		{

			p_f_(ar1);
			l=-1+strlen(rp_f);
			if(strlen(rp_f)==0){while(m>=0){ar2[ar2i]=fm[m];--ar2i;--m;}}else{
				while(l>=0){if(fm[m]==','){ar2[ar2i]=',';--ar2i;--m;}else{
					ar2[ar2i]=rp_f[l];--l;--ar2i;--m;}
				}
			}
			while(m>=0){ar2[ar2i]=fm[m];--ar2i;--m;}

		}else{

			p_f_(ar1);
			p_f_((ar1-p_v(rp_f))*pow(10,-1+strlen(fm)-i));
			k=-1+strlen(rp_f);
			l=(m-i)-strlen(rp_f);while(l>0){ar2[ar2i]='0';--l;--ar2i;}
			while(k>=0&&ar2i>=256-(m-i)){ar2[ar2i]=rp_f[k];--k;--ar2i;}
			ar2[ar2i]='.';--ar2i;m=-1+i;

			p_f_(ar1);
			l=-1+strlen(rp_f);
			while(l>=0){if(m>=0&&fm[m]==',')
			{ar2[ar2i]=fm[m];--ar2i;--m;}ar2[ar2i]=rp_f[l];--l;--ar2i;--m;}
			while(m>=0&&ar2i>=n){ar2[ar2i]=fm[m];--ar2i;--m;}

		}
	
	}else{

		p_f_(ar1);
		p_f_((ar1-p_v(rp_f))*pow(10,2));
		k=-1+strlen(rp_f);
		l=2;i=0;while(k>=0||l>i){if(k>=0){ar2[ar2i]=rp_f[k];--k;--ar2i;--l;}else{
			ar2[ar2i]='0';--ar2i;--l;}}ar2[ar2i]='.';--ar2i;m=1;

		p_f_(ar1);
		l=-1+strlen(rp_f);
		if(strlen(rp_f)==0){while(m>=0){ar2[ar2i]='0';--ar2i;--m;}}else{
			while(l>=0){ar2[ar2i]=rp_f[l];--l;--ar2i;}
		}

	}

	l=0;if(sig==1){ar2[l]='-';++l;for(i=1;i<256;++i){if(ar2[i]!='\0'){ar2[l]=ar2[i];++l;}}}else{
		for(i=0;i<256;++i){if(ar2[i]!='\0'){ar2[l]=ar2[i];++l;}}
	}
	for(i=l;i<256;++i){ar2[i]='\0';}

	for(i=0;i<strlen(ar2);++i){if(ar2[i]=='#'){ar2[i]=' ';}}
	for(i=0;i<strlen(ar2);++i){if(ar2[i]==' '&&ar2[i+1]==','){ar2[i+1]=' ';}}

	return(0);

}

int	c_p(char cl_a[256],int ci,bool tf,char r_a[256])
{

	int		a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}

	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;/*printf("%c",cl_a[c]);*/}

	return(0);

}

__int64 p_cs(char infn[256], int ns)
{


	int		fbyte;

	int		i,j,k,l,m,n,p,q;
	int		a,b,c,d;
	int 	d1,d2,d3;
	int		b8o,b8e,b16o,b16e;
	int		nH,nL;
	int		mx,mxi;

	__int64	bc=0;

	b8o=0;
	b8o|=1<<0;
	b8o|=1<<2;
	b8o|=1<<4;
	b8o|=1<<6;

	b8e=0;
	b8e|=1<<1;
	b8e|=1<<3;
	b8e|=1<<5;
	b8e|=1<<7;

	b16o=0;
	b16o|=1<<0;
	b16o|=1<<2;
	b16o|=1<<4;
	b16o|=1<<6;
	b16o|=1<<8;
	b16o|=1<<10;
	b16o|=1<<12;
	b16o|=1<<14;

	b16e=0;
	b16e|=1<<1;
	b16e|=1<<3;
	b16e|=1<<5;
	b16e|=1<<7;
	b16e|=1<<9;
	b16e|=1<<11;
	b16e|=1<<13;
	b16e|=1<<15;

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){
		ba16[i][j][k][l][0]=-1;ba16[i][j][k][l][1]=0;ba16[i][j][k][l][2]=0;
	}}}}
	for(i=0;i<16;++i){da[i][0]=-1;da[i][1]=0;da[i][2]=0;}

	f1=fopen(infn,"rb");

	nH=getc(f1);if(!feof(f1)){++bc;}nL=getc(f1);if(!feof(f1)){++bc;}
	while(!feof(f1))
	{
		n=(nH<<8)|nL;
		if(ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][0]==-1)
		{

			a=(n&0xf000)>>12;b=(n&0x0f00)>>8;
			d1=((((b16e&a)>>1)^((b16e&(b&0xffff))>>1))<<1)|((b16o&a)^(b16o&(b&0xffff)));
			a=(n&0x0f00)>>8;b=(n&0x00f0)>>4;
			d2=((((b16e&a)>>1)^((b16e&(b&0xffff))>>1))<<1)|((b16o&a)^(b16o&(b&0xffff)));
			a=(n&0x00f0)>>4;b=(n&0x000f)>>0;
			d3=((((b16e&a)>>1)^((b16e&(b&0xffff))>>1))<<1)|((b16o&a)^(b16o&(b&0xffff)));

			ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][0]=ba16i;
			ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][1]=1;
						
			if(d1>=d2&&d1>=d3){if(da[d1][0]==-1){da[d1][0]=1;ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d1;++ba16i;continue;}else{++da[d2][0];}ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d1;++ba16i;continue;}
			if(d2>=d1&&d2>=d3){if(da[d2][0]==-1){da[d2][0]=1;ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d2;++ba16i;continue;}else{++da[d2][0];}ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d2;++ba16i;continue;}
			if(d3>=d1&&d3>=d2){if(da[d3][0]==-1){da[d3][0]=1;ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d3;++ba16i;continue;}else{++da[d3][0];}ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][2]=d3;++ba16i;continue;}

		}else{
			++ba16[(n&0xf000)>>12][(n&0x0f00)>>8][(n&0x00f0)>>4][(n&0x000f)>>0][1];
		}
		nH=getc(f1);if(!feof(f1)){++bc;}nL=getc(f1);if(!feof(f1)){++bc;}
	}
	fclose(f1);

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){
		if(ba16[i][j][k][l][0]!=-1)
		{
			if(da[(ba16[i][j][k][l][2]&0xf)][0]!=-1)
			{
				da[(ba16[i][j][k][l][2]&0xf)][1]+=(i<<4)|j;	
				da[(ba16[i][j][k][l][2]&0xf)][2]+=(k<<4)|l;
			}else{
					da[l][0]=0;
					da[(ba16[i][j][k][l][2]&0xf)][1]+=(i<<4)|j;	
					da[(ba16[i][j][k][l][2]&0xf)][2]+=(k<<4)|l;
			}
		}
	}}}}

	//printf("\n%s\n\n",infn);

	return(bc);

}

int	p_21()
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;

	__int64 bc=0;

	//printf("!%s!%s!\n",dirn,v_ext);	
	p_d_(dirn,v_ext);

	f2=fopen(out2fn,"rb");
	f3=fopen(out3fn,"w");
	if(of){f4=fopen(out4fn,"wb");}

	fbyte=getc(f2);
	while (!feof(f2))
	{

		for(i=0;i<256;++i){dirn[i]='\0';}
		j=0;while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f2);}
		while(!feof(f2)&&(fbyte==13||fbyte==10)){fbyte=getc(f2);}

		//printf("%s\n",dirn);
		if(strlen(dirn)==0){break;}

		//stat(dirn,&fp);
		bc=p_cs(dirn,b12);

		p_format((double)bc,"000000000",p_s);

		if(bc==0){continue;}

		printf("FILENAME %s\nSIZE %s\n",dirn,p_s);
		fprintf(f3,"FILENAME %s\nSIZE %s\n",dirn,p_s);

		//printf("CHECKSUM STRING :\n");
		fprintf(f3,"CHECKSUM STRING :\n");
		j=0;for(i=0;i<512;++i){n_s[i]='\0';}
		for(a=0;a<16;++a)
		{
			if(da[a][0]!=-1)
			{
				//printf("%02d%05d%09d%012d\n",a,da[a][0],da[a][1],da[a][2]);
				fprintf(f3,"%02d%05d%09d%012d\n",a,da[a][0],da[a][1],da[a][2]);
				//p_format((double)a,"00",p_s);			
				//for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
				//p_format((double)da[a][0],"000",p_s);		
				//for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
				//p_format((double)da[a][1],"000000000",p_s);	
				//for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
				//p_format((double)da[a][2],"000000000000",p_s);	
				//for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
			}
		}
		//printf("\n");
		//for(j=0;j<-csl+1+strlen(n_s);j+=csl){for(i=j;i<j+csl;++i){/*printf("%c",n_s[i]);*/fprintf(f3,"%c",n_s[i]);}/*printf("\n");*/fprintf(f3,"\n");}
		if(of)
		{
			f1=fopen(dirn,"rb");if(f1==NULL){}else{
				m=getc(f1);while (!feof(f1)){fprintf(f4,"%c",m);m=getc(f1);}fclose(f1);}
		}	
		//break;
	}
	fclose(f2);
	fclose(f3);
	if(of){fclose(f4);}

	return(0);

}

int	p_21_(char ar_fn[256], char i_fn[256])
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;
	
	__int64 bc=0;

	f2=fopen(ar_fn,"ab");if(f2==NULL){}else{

		//stat(i_fn,&fp);		
		bc=p_cs(i_fn,b12);

		p_format((double)bc,"0000000000",p_s);
		printf("FILENAME %s%c%cSIZE %s%c%c",i_fn,(char)13,(char)10,p_s,(char)13,(char)10);
		fprintf(f2,"%s%c%c",p_s,(char)13,(char)10);

		f3=fopen(i_fn,"rb");if(f3==NULL){}else{
			fbyte=getc(f3);while (!feof(f3)){fprintf(f2,"%c",fbyte);fbyte=getc(f3);}
			fclose(f3);
		}
	}

	fprintf(f2,"FILENAME %s%c%cSIZE %s%c%c",i_fn,(char)13,(char)10,p_s,(char)13,(char)10);
	//printf("CHECKSUM STRING :\n");
	fprintf(f2,"CHECKSUM STRING :");fprintf(f2,"%c%c",(char)13,(char)10);
	j=0;for(i=0;i<512;++i){n_s[i]='\0';}
	for(a=0;a<16;++a)
	{
		if(da[a][0]!=-1)
		{
			//printf("%02d%05d%09d%012d",a,da[a][0],da[a][1],da[a][2]);
			fprintf(f2,"%02d%05d%09d%012d",a,da[a][0],da[a][1],da[a][2]);fprintf(f2,"%c%c",(char)13,(char)10);
			p_format((double)a,"00",p_s);			
			for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
			p_format((double)da[a][0],"000",p_s);		
			for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
			p_format((double)da[a][1],"000000000",p_s);	
			for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
			p_format((double)da[a][2],"000000000000",p_s);	
			for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
		}
	}
	fclose(f2);

	return(0);

}

int p_3(char dirn_[256])
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	char	dn[256];

	//printf("%s\n",dirn_);		
	
	for(i=0;i<strlen(dirn_);++i){if(dirn_[i]=='\\'||dirn_[i]=='\/'){break;}}m=i;
	while(m<strlen(dirn_))
	{
		for(k=0;k<256;++k){dn[k]='\0';}
		l=0;for(j=m+1;j<strlen(dirn_)&&dirn_[j]!='\\'&&dirn_[j]!='\/';++j){dn[l]=dirn_[j];++l;}/*printf("%s\n",dn);*/m=j;
		if(chdir(dn)==-1){mkdir_(dn);chdir(dn);}
	}

	return(0);

}

int	p_22_(char ar_fn[256] , char o_fn[10][256],int n_fn)
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m=0,n;
	int	fbyte,fbyte_,sfc=0;

	__int64	bc,tc=0;

	f2=fopen(ar_fn,"rb");if(f2==NULL){}else{fbyte=getc(f2);

		while(m<n_fn)
		{
		
			for(i=0;i<256;++i){p_s[i]='\0';}
			i=0;n=10;while(!feof(f2)&&i<n){p_s[i]=fbyte;++i;fbyte=getc(f2);}fbyte=getc(f2);fbyte=getc(f2);
		
			bc=(__int64)p_val(p_s);
			f3=fopen(o_fn[m],"wb");tc=0;while (!feof(f2)&&tc<bc){fprintf(f3,"%c",fbyte);++tc;fbyte=getc(f2);}fclose(f3);

			while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){fbyte=getc(f2);}while(!feof(f2)&&(fbyte==13||fbyte==10)){fbyte=getc(f2);}
			while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){fbyte=getc(f2);}while(!feof(f2)&&(fbyte==13||fbyte==10)){fbyte=getc(f2);}
			while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){fbyte=getc(f2);}while(!feof(f2)&&(fbyte==13||fbyte==10)){fbyte=getc(f2);}

			p_cs(o_fn[m],b12);

			for(a=0;a<16;++a)
			{
				if(da[a][0]!=-1)
				{
					j=0;for(i=0;i<512;++i){n_s[i]='\0';}
					p_format((double)a,"00",p_s);			
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][0],"00000",p_s);		
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][1],"000000000",p_s);	
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][2],"000000000000",p_s);	
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}

					for(i=0;i<256;++i){dirn[i]='\0';}
					j=0;while(!feof(f2)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f2);}fbyte=getc(f2);fbyte=getc(f2);

					if(strlen(dirn)!=0&&strlen(n_s)!=0)
					{
						if(strlen(dirn)==strlen(n_s))
						{
							l=0;for(k=0;dirn[k]>='0'&&dirn[k]<='9'&&n_s[k]>='0'&&n_s[k]<='9';++k)
							{if(dirn[k]!=n_s[k]){break;}else{++l;}}
							if(l!=csl){printf("2.CHEKSUM Error...!%s! !%s! !%d!\n",dirn,n_s,l);return(0);}else{/*printf("%02d",a);*/}

						}else{printf("1.CHEKSUM Error...!%s! !%s! !%d %d!\n",dirn,n_s,strlen(dirn),strlen(n_s));return(0);}
					}
				}
			
			}
			printf("Restored %s Ok\n",o_fn[m]);
			
			++m;
		}
	}	
	return(0);
}	

int	p_22()
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;
	char	dn[256];

	f4=fopen(out4fn,"rb");
	f3=fopen(out3fn,"rb");

	fbyte=getc(f3);
	while (!feof(f3))
	{

		for(i=0;i<256;++i){dirn[i]='\0';}
		j=0;while(!feof(f3)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f3);}
		while(!feof(f3)&&(fbyte==13||fbyte==10)){fbyte=getc(f3);}
		
		if(strlen(dirn)==0){continue;}

		for(i=0;i<strlen(r1);++i){if(r1[i]!=dirn[i]){break;}}
		if(i==strlen(r1))
		{

			//printf("%s\n",dirn);
			
			for(j=-1+strlen(dirn);j>=i+1;--j){if(dirn[j]=='\\'||dirn[j]=='\/'){break;}}

			for(k=0;k<256;++k){outfilen[k]='\0';}
			l=0;for(k=j+1;k<strlen(dirn);++k){outfilen[l]=dirn[k];++l;}

			for(k=0;k<256;++k){outdir[k]='\0';}
			l=0;for(k=i;k<=j;++k){outdir[l]=dirn[k];++l;}

			for(i=0;i<256;++i){dn[i]='\0';}
			m=0;for(i=0;i<strlen(outdir);++i){
			if(m>0&&(outdir[i]=='\\'||outdir[i]=='\/')&&(dn[m-1]=='\\'||dn[m-1]=='\/')){}else{dn[m]=outdir[i];++m;}}
			for(i=0;i<256;++i){outdir[i]='\0';}
			m=0;for(i=0;i<strlen(dn);++i){outdir[m]=dn[i];++m;}

			for(i=0;i<256;++i){dn[i]='\0';}
			m=0;for(i=0;i<strlen(outpath);++i){
			if(m>0&&(outpath[i]=='\\'||outpath[i]=='\/')&&(dn[m-1]=='\\'||dn[m-1]=='\/')){}else{dn[m]=outpath[i];++m;}}
			for(i=0;i<256;++i){outpath[i]='\0';}
			m=0;for(i=0;i<strlen(dn);++i){outpath[m]=dn[i];++m;}

			//printf("%s\n%s\n%s\n",outdir,outfilen,outpath);
			//printf("%s\n",outfilen);

			if(chdir(outpath)==-1){mkdir_(outpath);chdir(outpath);}p_3(outdir);

			for(;i<strlen(dirn);++i){if(dirn[i]=='\\'||dirn[i]=='\/'){break;}}
			l=strlen(outpath);m=l;for(k=i+1;k<=j;++k){outpath[l]=dirn[k];++l;}			
			l=strlen(outpath);for(k=0;k<strlen(outfilen);++k){outpath[l]=outfilen[k];++l;}
			
			//printf("%s\n",outpath);			
			
			//for(k=m;k<256;++k){outpath[k]='\0';}
			continue;

		}

		for(i=0;i<strlen(r2);++i){if(r2[i]!=dirn[i]){break;}}
		if(i==strlen(r2))
		{
			for(k=0;k<256;++k){p_s[k]='\0';}
			l=0;for(j=i+1;j<strlen(dirn);++j){p_s[l]=dirn[j];++l;}
			n=(int)p_val(p_s);

			//printf("%s %s %d\n",dirn,p_s,n);

			f5=fopen(outpath,"wb");
			fbyte_=getc(f4);fprintf(f5,"%c",fbyte_);++sfc;
			while(!feof(f4)&&sfc<n){fbyte_=getc(f4);fprintf(f5,"%c",fbyte_);++sfc;}fclose(f5);sfc=0;

			//for(k=m;k<256;++k){outpath[k]='\0';}
			continue;
		}

		for(i=0;i<strlen(r3);++i){if(r3[i]!=dirn[i]){break;}}
		if(i==strlen(r3))
		{

			//printf("%s %s\n",dirn,outpath);

			p_cs(outpath,b12);

			for(a=0;a<16;++a)
			{
				if(da[a][0]!=-1)
				{
					j=0;for(i=0;i<512;++i){n_s[i]='\0';}
					p_format((double)a,"00",p_s);			
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][0],"00000",p_s);		
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][1],"000000000",p_s);	
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}
					p_format((double)da[a][2],"000000000000",p_s);	
					for(i=0;i<strlen(p_s);++i){n_s[j]=p_s[i];++j;}

					for(i=0;i<256;++i){dirn[i]='\0';}
					j=0;while(!feof(f3)&&(fbyte!=13&&fbyte!=10)){dirn[j]=fbyte;++j;fbyte=getc(f3);}
					while(!feof(f3)&&(fbyte==13||fbyte==10)){fbyte=getc(f3);}

					if(strlen(dirn)!=0&&strlen(n_s)!=0)
					{
						if(strlen(dirn)==strlen(n_s))
						{
							l=0;for(k=0;dirn[k]>='0'&&dirn[k]<='9'&&n_s[k]>='0'&&n_s[k]<='9';++k)
							{if(dirn[k]!=n_s[k]){break;}else{++l;}}
							if(l!=csl){printf("2.CHEKSUM Error...!%s! !%s! !%d!\n",dirn,n_s,l);return(0);}else{/*printf("%02d",a);*/}

						}else{printf("1.CHEKSUM Error...!%s! !%s! !%d %d!\n",dirn,n_s,strlen(dirn),strlen(n_s));return(0);}
					}
				}
			}
			printf("\nRestored %s Ok\n",outpath);

			for(k=m;k<256;++k){outpath[k]='\0';}
			continue;
		}

	}
	fclose(f3);

	return(0);

}

int main(int argc,char *argv[])
{


	char	cmd[50][256];

	char	c_1[256];
	char	c_2[256];
	char	c_3[256];
	char	c_4[256];
	char	c_5[256];
	char	c_6[256];

	char	c_1_[20][256];
	char	f_1_[20][256];

	int	a,b,c,ci,d;
	int	i,j,k,l,m,n;
	int	fbyte,fbyte_,sfc=0;


	//
	printf("\nMLS File packager \nwritten by Dzinleski Jasenko 2010 , 2011 , 2012 , May , 5 , 2013\n");
	printf("\n");
	printf("\nOS Win32 VRM 1.7.7\n\n");
	//


	if((argv[1]!=NULL)&&((argv[1][0]=='-'&&argv[1][1]=='e')||(argv[1][0]=='-'&&argv[1][1]=='l')))
	{
			printf("\n\n");
			printf("\nMLS file packager written by Dzinleski Jasenko 2010 - 2013\n");
			printf("\n");
			printf("\nOS Win32 VRM 1.7.7\n\n");
			printf("\n");
			printf("\tThis source and file packager method apply to GNU General Public License.\n");
			printf("\t		Copyright (C) 2010 and later Jasenko Dzinleski \n");
			printf("\n");
			printf("\t	This program is free software; you can redistribute it\n");
			printf("\tand/or modify it under the terms of the GNU General Public License as\n");
			printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
			printf("\tLicense, or (at your option) any later version.\n");
			printf("\n");
			printf("\tThis program is distributed in the hope that it will be useful, but\n");
			printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
			printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
			printf("\tGeneral Public License for more details.\n");
			printf("\n");
			printf("\tYou should have received a copy of the GNU General Public License along\n");
			printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
			printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
			printf("\n");

			return(0);

	}

	if((argv[1]!=NULL)&&(argv[1][0]=='-'&&argv[1][1]=='h'))
	{

			printf("\nMLS File packager \nwritten by Dzinleski Jasenko 2010 - 2013\n");
			printf("\n");
			printf("\nOS Win32 VRM 1.7.7\n\n");
			printf("To create : mls_1 {[-c]|[-r]|[-e]|[-l]|[-h]} <Source Path> {[drive:][\\path...\\]} [*|*.[ext]] \nTo restore : mls_1 {[-c]|[-r]|[-e]|[-l]|[-h]} <Ouput Path> {[drive:][\\path...\\]} \n");
			printf("mls_A11.mar file will be created in the current path\n");
			printf("\n");

			return(0);
	}

	if(argv[1]==NULL||argv[2]==NULL){return(0);}else{

		if((argv[1][0]=='-'&&argv[1][1]=='c')||(argv[1][0]=='-'&&argv[1][1]=='r')){}else{printf("Command sw. Error...\n");return(0);}
	}

	for(j=0;j<256;++j){dirn[j]='\0';}
	for(j=0;j<256;++j){v_ext[j]='\0';}
	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}


	//------------

	ci=1;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}

	ci=1;
	for(i=0;i<256;++i){c_6[i]='\0';}
	c_p(c_1,ci,false,c_6);
	//for(i=0;i<strlen(c_6);++i){printf("%c",c_6[i]);}


	ci=2;
	for(i=0;i<256;++i){c_5[i]='\0';}
	c_p(c_1,ci,false,c_5);
	//for(i=0;i<strlen(c_5);++i){printf("%c",c_5[i]);}


	ci=2;
	for(i=0;i<256;++i){c_3[i]='\0';}
	c_p(c_l,ci,true,c_3);
	//for(i=0;i<strlen(c_3);++i){printf("%c",c_3[i]);}

	ci=1;
	for(i=0;i<256;++i){c_4[i]='\0';}
	c_p(c_3,ci,false,c_4);
	//for(i=0;i<strlen(c_4);++i){printf("%c",c_4[i]);}

	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{

	if(os==1)
	{

	//Input Drive Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i)
	{
		if
		(
			(cmd[2][i]>=c_6[0]&&cmd[2][i]<=c_6[1])||
			(cmd[2][i]>=c_5[0]&&cmd[2][i]<=c_5[1])

		){dirn[dirni]=cmd[2][i];++dirni;}else{break;}
	}
	if(cmd[2][i]==c_4[0]){}else{printf("Input Drive Spec. Error...\n");return(0);}
	dirn[dirni]=':';++dirni;

	}

	}

	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

	if(os==1)
	{

	//Output Drive Spec.
	l=0;
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i)
	{
		if
		(
			(cmd[2][i]>=c_6[0]&&cmd[2][i]<=c_6[1])||
			(cmd[2][i]>=c_5[0]&&cmd[2][i]<=c_5[1])

		){outpath[l]=cmd[2][i];++l;}else{break;}
	}
	if(cmd[2][i]==c_4[0]){}else{printf("Output Drive Spec. Error...\n");return(0);}
	outpath[l]=':';++l;

	}

	}
	//------------


	ci=3;
	for(i=0;i<256;++i){c_1[i]='\0';}
	c_p(c_l,ci,true,c_1);
	//for(i=0;i<strlen(c_1);++i){printf("%c",c_1[i]);}


	ci=1;
	for(i=0;i<256;++i){c_1_[1][i]='\0';}
	c_p(c_1,ci,false,c_1_[1]);
	ci=2;
	for(i=0;i<256;++i){c_1_[2][i]='\0';}
	c_p(c_1,ci,false,c_1_[2]);
	ci=3;
	for(i=0;i<256;++i){c_1_[3][i]='\0';}
	c_p(c_1,ci,false,c_1_[3]);
	ci=4;
	for(i=0;i<256;++i){c_1_[4][i]='\0';}
	c_p(c_1,ci,false,c_1_[4]);
	ci=5;
	for(i=0;i<256;++i){c_1_[5][i]='\0';}
	c_p(c_1,ci,false,c_1_[5]);
	ci=6;
	for(i=0;i<256;++i){c_1_[6][i]='\0';}
	c_p(c_1,ci,false,c_1_[6]);
	ci=7;
	for(i=0;i<256;++i){c_1_[7][i]='\0';}
	c_p(c_1,ci,false,c_1_[7]);
	ci=8;
	for(i=0;i<256;++i){c_1_[8][i]='\0';}
	c_p(c_1,ci,false,c_1_[8]);
	ci=9;
	for(i=0;i<256;++i){c_1_[9][i]='\0';}
	c_p(c_1,ci,false,c_1_[9]);
	ci=10;
	for(i=0;i<256;++i){c_1_[10][i]='\0';}
	c_p(c_1,ci,false,c_1_[10]);
	ci=11;
	for(i=0;i<256;++i){c_1_[11][i]='\0';}
	c_p(c_1,ci,false,c_1_[11]);
	ci=12;
	for(i=0;i<256;++i){c_1_[12][i]='\0';}
	c_p(c_1,ci,false,c_1_[12]);
	ci=13;
	for(i=0;i<256;++i){c_1_[13][i]='\0';}
	c_p(c_1,ci,false,c_1_[13]);


	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{

	//Input Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i){}if(i==strlen(cmd[2])){i=-1;}

	for(j=i+1;j<strlen(cmd[2]);++j)
	{
		if
		(
			(cmd[2][j]>=c_1_[1][0]&&cmd[2][j]<=c_1_[1][1])||
			(cmd[2][j]>=c_1_[2][0]&&cmd[2][j]<=c_1_[2][1])||
			(cmd[2][j]>=c_1_[3][0]&&cmd[2][j]<=c_1_[3][1])||
			(cmd[2][j]>=c_1_[4][0]&&cmd[2][j]<=c_1_[4][1])||
			(cmd[2][j]>=c_1_[5][0]&&cmd[2][j]<=c_1_[5][1])||
			(cmd[2][j]>=c_1_[6][0]&&cmd[2][j]<=c_1_[6][1])||
			(cmd[2][j]>=c_1_[8][0]&&cmd[2][j]<=c_1_[8][1])||
			(cmd[2][j]>=c_1_[10][0]&&cmd[2][j]<=c_1_[10][1])||
			(cmd[2][j]>=c_1_[11][0]&&cmd[2][j]<=c_1_[11][1])

		){if(cmd[2][j]!='\''&&cmd[2][j]!='"'){dirn[dirni]=cmd[2][j];++dirni;}}else{break;}
	}
	if(j==strlen(cmd[2])){}else{

		for(i=j;i<strlen(cmd[2]);++i)
		{
			if
			(
				(cmd[2][i]>=c_1_[1][0]&&cmd[2][i]<=c_1_[1][1])||
				(cmd[2][i]>=c_1_[2][0]&&cmd[2][i]<=c_1_[2][1])||
				(cmd[2][i]>=c_1_[3][0]&&cmd[2][i]<=c_1_[3][1])||
				(cmd[2][i]>=c_1_[4][0]&&cmd[2][i]<=c_1_[4][1])||
				(cmd[2][i]>=c_1_[5][0]&&cmd[2][i]<=c_1_[5][1])||
				(cmd[2][i]>=c_1_[6][0]&&cmd[2][i]<=c_1_[6][1])||
				(cmd[2][i]>=c_1_[7][0]&&cmd[2][i]<=c_1_[7][1])||
				(cmd[2][i]>=c_1_[10][0]&&cmd[2][i]<=c_1_[10][1])
		
			)
			{

				if
				(
				(cmd[2][i]>=c_1_[1][0]&&cmd[2][i]<=c_1_[1][1])||
				(cmd[2][i]>=c_1_[2][0]&&cmd[2][i]<=c_1_[2][1])||
				(cmd[2][i]>=c_1_[3][0]&&cmd[2][i]<=c_1_[3][1])||
				(cmd[2][i]>=c_1_[4][0]&&cmd[2][i]<=c_1_[4][1])||
				(cmd[2][i]>=c_1_[5][0]&&cmd[2][i]<=c_1_[5][1])||
				(cmd[2][i]>=c_1_[7][0]&&cmd[2][i]<=c_1_[7][1])||
				(cmd[2][i]>=c_1_[10][0]&&cmd[2][i]<=c_1_[10][1])

				){v_ext[vexti]=cmd[2][i];++vexti;}
			

			}else{break;}
		}
		if(i==strlen(cmd[2])){}else{printf("Input Path Spec. Error...\n");return(0);}

	}

	}

	
	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

	//Output Spec.
	for(i=0;i<strlen(cmd[2])&&cmd[2][i]!=c_4[0];++i){}if(i==strlen(cmd[2])){i=-1;}

	
	for(j=i+1;j<strlen(cmd[2]);++j)
	{
		if
		(
			(cmd[2][j]>=c_1_[1][0]&&cmd[2][j]<=c_1_[1][1])||
			(cmd[2][j]>=c_1_[2][0]&&cmd[2][j]<=c_1_[2][1])||
			(cmd[2][j]>=c_1_[3][0]&&cmd[2][j]<=c_1_[3][1])||
			(cmd[2][j]>=c_1_[4][0]&&cmd[2][j]<=c_1_[4][1])||
			(cmd[2][j]>=c_1_[5][0]&&cmd[2][j]<=c_1_[5][1])||
			(cmd[2][j]>=c_1_[6][0]&&cmd[2][j]<=c_1_[6][1])||
			(cmd[2][j]>=c_1_[8][0]&&cmd[2][j]<=c_1_[8][1])||
			(cmd[2][j]>=c_1_[10][0]&&cmd[2][j]<=c_1_[10][1])||
			(cmd[2][j]>=c_1_[11][0]&&cmd[2][j]<=c_1_[11][1])


		){outpath[l]=cmd[2][j];++l;}else{break;}
	}
	if(j==strlen(cmd[2])){}else{printf("Output Path Spec. Error...\n");return(0);}

	}

	if(argv[1][0]=='-'&&argv[1][1]=='c')
	{

		p_21();

		f2=fopen("mls_A11.mar","wb");
		fclose(f2);

		p_21_("mls_A11.mar","mls_o1.mar");
		p_21_("mls_A11.mar","mls_o2.mar");
		p_21_("mls_A11.mar","mls_o3.mar");
		p_21_("mls_A11.mar","mls_o4.mar");

		remove("mls_o1.mar");
		remove("mls_o2.mar");
		remove("mls_o3.mar");
		remove("mls_o4.mar");

	}
	if(argv[1][0]=='-'&&argv[1][1]=='r')
	{

		for(i=0;i<10;++i){for(j=0;j<256;++j){f_1_[i][j]='\0';}}
		strcpy(f_1_[0],out1fn);
		strcpy(f_1_[1],out2fn);
		strcpy(f_1_[2],out3fn);
		strcpy(f_1_[3],out4fn);

		p_22_("mls_A11.mar",f_1_,4);

		p_22();

		remove("mls_o1.mar");
		remove("mls_o2.mar");
		remove("mls_o3.mar");
		remove("mls_o4.mar");

	}

	return(0);

}

